%define anolis_release .0.2
%global _smp_mflags -j1

%if 0%{?fedora} == 0
%global debug_package   %{nil}
%global _unpackaged_files_terminate_build 0
%global _missing_build_ids_terminate_build 0
%define __debug_install_post   \
   %{_rpmconfigdir}/find-debuginfo.sh %{?_find_debuginfo_opts} "%{_builddir}/%{?buildsubdir}"\
%{nil}
%endif

%global sname deepin-daemon
%global repo dde-daemon
%global release_name server-industry

%global patch_ver +176995

%if 0%{?fedora}
Name:           %{sname}
%else
Name:           dde-daemon
%endif
Version:        5.14.122
Release:        1%{anolis_release}%{?dist}.07
Summary:        Daemon handling the DDE session settings
License:        GPLv3
URL:            https://github.com/linuxdeepin/dde-daemon
Source0:        %{url}/archive/%{version}/%{repo}-%{version}.tar.gz
%if 0%{?fedora}
# upstream default mono font set to 'Noto Mono', which is not yet available in
# Fedora. We change to 'Noto Sans Mono'
Source1:        fontconfig.json
Source2:        %{sname}.sysusers
%endif

#add uos patch
#pms 182839
Patch0001:      0001-fix-fonts-gb-st-super.patch
#pms 195291
Patch0002:      0002-donot-set-cpu-mode-while-initlizing.patch
Patch0003:      0003-dde-daemon-uos-fix-failed-to-start-accounts-service.patch  
#end

BuildRequires:  python3

%if 0%{?fedora}
ExclusiveArch:  %{?go_arches:%{go_arches}}%{!?go_arches:%{ix86} x86_64 aarch64 %{arm}}
BuildRequires:  systemd-rpm-macros
BuildRequires:  golang(pkg.deepin.io/dde/api/dxinput) >= 3.1.26
BuildRequires:  golang(github.com/linuxdeepin/go-dbus-factory/org.bluez)
BuildRequires:  golang(github.com/linuxdeepin/go-x11-client)
BuildRequires:  golang(github.com/BurntSushi/xgb)
BuildRequires:  golang(github.com/BurntSushi/xgbutil)
BuildRequires:  golang(github.com/axgle/mahonia)
BuildRequires:  golang(github.com/msteinert/pam)
BuildRequires:  golang(github.com/nfnt/resize)
BuildRequires:  golang(github.com/cryptix/wav)
BuildRequires:  golang(gopkg.in/alecthomas/kingpin.v2)
BuildRequires:  golang(gopkg.in/yaml.v2)
BuildRequires:  golang(github.com/gosexy/gettext)
BuildRequires:  golang(github.com/jinzhu/gorm)
BuildRequires:  golang(github.com/jinzhu/gorm/dialects/sqlite)
BuildRequires:  golang(github.com/kelvins/sunrisesunset)
BuildRequires:  golang(github.com/rickb777/date)
BuildRequires:  golang(github.com/teambition/rrule-go)
BuildRequires:  golang(github.com/davecgh/go-spew/spew)
BuildRequires:  golang-dbus
BuildRequires:  golang-github-fsnotify-fsnotify-devel
BuildRequires:  golang-github-mozillazg-pinyin
BuildRequires:  golang-github-lofanmi-pinyin
BuildRequires:  golang-github-stretchr-testify-devel
BuildRequires:  golang-x-sys-devel
BuildRequires:  golang-x-xerrors-devel
BuildRequires:  golang-x-image-devel
%else
%if 0%{?openeuler}
%systemd_requires

%else
BuildRequires:  libddcutil-devel
BuildRequires:  resize-devel
BuildRequires:  gorm-devel
BuildRequires:  inflection-devel
BUildRequires:  deepin-desktop-schemas
%endif
%endif
BuildRequires:  compiler(go-compiler)
BuildRequires:  deepin-gettext-tools
BuildRequires:  fontpackages-devel
BuildRequires:  librsvg2-tools
BuildRequires:  pam-devel >= 1.3.1
BuildRequires:  glib2-devel
BuildRequires:  gtk3-devel
BuildRequires:  systemd-devel
BuildRequires:  alsa-lib-devel
BuildRequires:  pulseaudio-libs-devel
BuildRequires:  gdk-pixbuf2-xlib-devel
BuildRequires:  libnl3-devel
BuildRequires:  libgudev-devel
BuildRequires:  libinput-devel
BuildRequires:  librsvg2-devel
BuildRequires:  libXcursor-devel
BuildRequires:  pkgconfig(sqlite3)
BuildRequires:  go-lib-devel
BuildRequires:  libX11-devel
BuildRequires:  dde-api-devel
BuildRequires:  go-x11-client-devel
BuildRequires:  go-dbus-factory-devel
BuildRequires:  golang(github.com/linuxdeepin/go-gir/gio-2.0)
BuildRequires:  golang(github.com/linuxdeepin/go-gir/glib-2.0)
BuildRequires:  golang(github.com/linuxdeepin/go-gir/gobject-2.0)
BuildRequires:  golang(github.com/linuxdeepin/go-gir/gudev-1.0)
BuildRequires:  pkgconfig(ddcutil)
BuildRequires:  gocode

Requires:       bluez-libs
Requires:       deepin-desktop-base
Requires:       deepin-desktop-schemas
Requires:       dde-polkit-agent
Requires:       rfkill
%if 0%{?openeuler}
Requires:       gvfs
%else
Requires:       gvfs gvfs-smb
%endif
Requires:       iw
Requires:       xdotool
Requires:       gnome-keyring-pam
Requires:       imwheel
Requires:       proxychains-ng
Requires:       deepin-proxy

Recommends:     iso-codes
Recommends:     mobile-broadband-provider-info
Recommends:     google-noto-mono-fonts
Recommends:     google-noto-sans-fonts

%description
Daemon handling the DDE session settings

%prep
%autosetup -p1 -n %{name}-%{version}
patch langselector/locale.go < rpm/locale.go.patch
patch accounts/users/passwd.go < rpm/passwd.go.patch

# Fix library exec path
sed -i '/deepin/s|lib|libexec|' Makefile
sed -i '/systemd/s|lib|usr/lib|' Makefile
sed -i 's:/lib/udev/rules.d:%{_udevrulesdir}:' Makefile
sed -i '/${DESTDIR}\/usr\/lib\/deepin-daemon\/service-trigger/s|${DESTDIR}/usr/lib/deepin-daemon/service-trigger|${DESTDIR}/usr/libexec/deepin-daemon/service-trigger|g' Makefile
sed -i '/${DESTDIR}${PREFIX}\/lib\/deepin-daemon/s|${DESTDIR}${PREFIX}/lib/deepin-daemon|${DESTDIR}${PREFIX}/usr/libexec/deepin-daemon|g' Makefile
sed -i 's|lib/NetworkManager|libexec|' network/utils_test.go

for file in $(grep "/usr/lib/deepin-daemon" * -nR |awk -F: '{print $1}')
do
    sed -i 's|/usr/lib/deepin-daemon|/usr/libexec/deepin-daemon|g' $file
done
for file in $(grep "/usr/lib/deepin-api" * -nR | awk -F: '{print $1}')
do
    sed -i 's|/usr/lib/deepin-api|%{_libexecdir}/deepin-api|g' $file
done
# Fix grub.cfg path
sed -i 's|boot/grub|boot/grub2|' grub2/{grub2,grub_params,theme}.go

# Fix activate services failed (Permission denied)
# dbus service
pushd misc/system-services/
sed -i '$aSystemdService=deepin-accounts-daemon.service' com.deepin.system.Power.service \
    com.deepin.daemon.{Accounts,Apps,Daemon}.service \
    com.deepin.daemon.{Gesture,SwapSchedHelper,Timedated}.service
sed -i '$aSystemdService=dbus-com.deepin.dde.lockservice.service' com.deepin.dde.LockService.service
popd
# systemd service
cat > misc/systemd/services/dbus-com.deepin.dde.lockservice.service <<EOF
[Unit]
Description=Deepin Lock Service
Wants=user.slice dbus.socket
After=user.slice dbus.socket

[Service]
Type=dbus
BusName=com.deepin.dde.LockService
ExecStart=%{_libexecdir}/%{sname}/dde-lockservice

[Install]
WantedBy=graphical.target
EOF

# Replace reference of google-chrome to chromium-browser
sed -i 's/google-chrome/chromium-browser/g' misc/dde-daemon/mime/data.json

# grub2 获取os num的忽略标题修改 UnionTech OS -> UOS
sed -i 's|UnionTech OS|UOS|' grub2/grub_params.go

%build
go env -w GO111MODULE="off"
%ifarch loongarch64
export CGO_ENABLED=1
export GOOS=linux
%endif

BUILDID="0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \n')"
%if 0%{?fedora}
export GOPATH="$(pwd)/build:%{gopath}"
%else
export GOPATH=/usr/share/gocode
%endif
%make_build GO_BUILD_FLAGS=-trimpath GOBUILD="go build -compiler gc -ldflags \"-B $BUILDID\""

%install
%ifarch loongarch64
export CGO_ENABLED=1
export GOOS=linux
%endif

BUILDID="0x$(head -c20 /dev/urandom|od -An -tx1|tr -d ' \n')"
%if 0%{?fedora}
export GOPATH="$(pwd)/build:%{gopath}"
%else
export GOPATH=/usr/share/gocode
%endif
%make_install GOBUILD="go build -compiler gc -ldflags \"-B $BUILDID\""

%if 0%{?fedora}
install -Dm644 %{SOURCE2} %{buildroot}/usr/lib/sysusers.d/%{name}.conf
%endif

# fix systemd/logind config
install -d %{buildroot}/usr/lib/systemd/logind.conf.d/
cat > %{buildroot}/usr/lib/systemd/logind.conf.d/10-%{sname}.conf <<EOF
[Login]
HandlePowerKey=ignore
HandleSuspendKey=ignore
EOF

%if 0%{?fedora}
# install default settings
install -Dm644 %{SOURCE1} \
    %{buildroot}%{_datadir}/deepin-default-settings/fontconfig.json
%endif

%find_lang %{name}

%post
if [ $1 -ge 1 ]; then
  systemd-sysusers %{sname}.conf
  %{_sbindir}/alternatives --install %{_bindir}/x-terminal-emulator \
    x-terminal-emulator %{_libexecdir}/%{sname}/default-terminal 30
fi
%systemd_post deepin-accounts-daemon.service
if [ $1 -eq 2 ] ; then
        # Upgrade installation
        systemctl --no-reload preset deepin-accounts-daemon.service  &>/dev/null || :
fi

%preun
if [ $1 -eq 0 ]; then
  %{_sbindir}/alternatives --remove x-terminal-emulator \
    %{_libexecdir}/%{sname}/default-terminal
fi
%systemd_preun deepin-accounts-daemon.service


%postun
if [ $1 -eq 0 ]; then
  rm -f /var/cache/deepin/mark-setup-network-services
  rm -f /var/log/deepin.log
fi
%systemd_postun_with_restart deepin-accounts-daemon.service

%files -f %{name}.lang
%doc README.md
%license LICENSE
%{_sysconfdir}/pam.d/deepin-auth-keyboard
%{_sysconfdir}/NetworkManager/conf.d/deepin.dde.daemon.conf
%{_libexecdir}/%{sname}/
%{_prefix}/lib/systemd/logind.conf.d/10-%{sname}.conf
%{_datadir}/dbus-1/services/*.service
%{_datadir}/dbus-1/system-services/*.service
%{_datadir}/dbus-1/system.d/*.conf
%{_datadir}/icons/hicolor/*/status/*
%{_datadir}/%{name}/
%{_datadir}/dde/
%{_datadir}/polkit-1/actions/*.policy
%{_var}/lib/polkit-1/localauthority/10-vendor.d/com.deepin.daemon.Accounts.pkla
%{_sysconfdir}/acpi/actions/deepin_lid.sh
%{_sysconfdir}/acpi/events/deepin_lid
%{_sysconfdir}/lightdm/deepin/xsettingsd.conf
# This directory is not provided by any other package.
%dir %{_sysconfdir}/pulse/daemon.conf.d
%{_sysconfdir}/pulse/daemon.conf.d/10-deepin.conf
%{_udevrulesdir}/80-deepin-fprintd.rules
%{_var}/lib/polkit-1/localauthority/10-vendor.d/com.deepin.daemon.Fprintd.pkla
%{_unitdir}/dbus-com.deepin.dde.lockservice.service
%{_unitdir}/deepin-accounts-daemon.service
%if 0%{?fedora}
%{_sysusersdir}/%{name}.conf
%{_datadir}/deepin-default-settings/
%exclude %{_sysconfdir}/default/grub.d/10_deepin.cfg
%exclude %{_sysconfdir}/grub.d/35_deepin_gfxmode
%exclude %{_libexecdir}/%{name}/grub2
%exclude %{_datadir}/dbus-1/system-services/com.deepin.daemon.Grub2.service
%exclude %{_datadir}/dbus-1/system.d/com.deepin.daemon.Grub2.conf
%exclude %{_datadir}/polkit-1/actions/com.deepin.daemon.Grub2.policy
%exclude %{_var}/lib/polkit-1/localauthority/10-vendor.d/com.deepin.daemon.Grub2.pkla
%else
%{_sysconfdir}/default/grub.d/10_deepin.cfg
%{_var}/lib/polkit-1/localauthority/10-vendor.d/com.deepin.daemon.Grub2.pkla
%endif
%{_sysconfdir}/deepin/
%{_libexecdir}/%{repo}
%{_datadir}/deepin/
%{_datadir}/dsg/

%changelog
* Fri Jan 12 2024 yangxianzhao <yangxianzhao@uniontech.com> - 5.14.122-1.07.0.2
- rebuild for qt5-qtbase

* Wed Sep 20 2023 yangxianzhao <yangxianzhao@uniontech.com> - 5.14.122-1.07.0.1
- rebuild for qt5-qtbase-5.15.3

* Mon May 22 2023 leeffo <liweiganga@uniontech.com> - 5.14.122-1.07
- feat: grub2 获取os num的忽略标题修改

* Tue Apr 25 2023 lichao <lichaod@uniontech.com> - 5.14.122-1.06
- fix: fix  Failed to start Accounts Service error (bugid:189853)

* Wed Apr 12 2023 zhaoshuang <zhaoshuang@uniontech.com> - 5.14.122-1.05
- rebuild: rebuild

* Wed Apr 12 2023 zhaoshuang <zhaoshuang@uniontech.com> - 5.14.122-1.04
- rebuild: rebuild

* Tue Apr 11 2023 zhaoshuang <zhaoshuang@uniontech.com> - 5.14.122-1.03
- fix: don't set cpu mode while initlizing(bugid:195291)

* Thu Apr 06 2023 lichao <lichaod@uniontech.com> - 5.14.122-1.02
- fix: fix Samba client connect error  (bugid:192683)

* Thu Feb 02 2023 liweiganga <liweiganga@uniontech.com> - 5.14.122-1.01
- feat: sync pms#182839 patch

* Fri Dec 30 2022 liweiganga <liweiganga@uniontech.com> - 5.14.122-1
- update: update to 5.14.122

* Wed Aug 17 2022 herengui <herengui@uniontech.com> - 5.13.85.8-2
- fix: update to 5.13.85.8+176995

* Wed Jun 29 2022 mahailiang <mahailiang@uniontech.com> - 5.8.34.3-2.05
- fix: remove 'go env -w GO111MODULE=auto' fix service start error

* Tue Jun 28 2022 liweiganga <liweiganga@uniontech.com> - 5.8.34.3-2.03
- fix: add requires deepin-proxy

* Fri Jun 10 2022 uoser <uoser@uniontech.com> - 5.13.85.8-1.03
- Update to 5.13.85.8

